-- ptr check
-- local build = GetBuildInfo()
-- if build ~= "4.0.6" then return end

-- don't load if class is wrong
-- local _, class = UnitClass("player")
-- if class ~= "SHAMAN" then return end

-- clcInfo_Options is loaded on demand so won't be available when this addon loads
-- this means you'll have to do the initalization in a function
local mod, options, baseMod, db, BaseDB

local modName = "__enhancement"

local function Get(info)
	return baseDB[info[#info]]
end

local function Set(info, val)
	baseDB[info[#info]] = val
	
	if info[#info] == "prio" or info[#info] == "prioAoe" then
		baseMod:UpdateQueue()
	end
end

local function LoadModule()
	if not clcInfo.activeTemplate then return end
	mod = clcInfo_Options
	options = mod.options
	baseMod = clcInfo.classModules[modName]
	db = clcInfo:RegisterClassModuleDB(modName)
	baseDB = clcInfo.activeTemplate.classModules[modName]
	
	local tx = {}
	for k, v in pairs(baseMod.actions) do
		table.insert(tx, format("\n%s - %s", k, v.info))
	end
	table.sort(tx)
	local prioInfo = "Legend:\n" .. table.concat(tx)
	
	options.args.classModules.args[modName] = {
		order = 4, type = "group", childGroups = "tab", name = "Enhancement",
		args = {
			tabPriority = {
				order = 1, type = "group", name = "Priority", args = {
					igPrio = {
						order = 1, type = "group", inline = true, name = "",
						args = {
							info = {
								order = 1, type = "description", name = prioInfo,
							},
							normalPrio = {
								order = 2, type="group", inline = true, name = "Normal priority",
								args = {
									prio = {
										order = 2, type = "input", width = "full", name = "",
										get = Get, set = Set,
									},
									infoCMD = {
										order = 3, type = "description", name = "Sample command line usage: /clcinfo enhprio fs es lb",
									},
								},
							},
							aoePrio = {
								order = 3, type="group", inline = true, name = "AoE priority",
								args = {
									prioAoe = {
										order = 2, type = "input", width = "full", name = "",
										get = Get, set = Set,
									},
									infoCMD = {
										order = 3, type = "description", name = "Sample command line usage: /clcinfo enhprioaoe eq es cl",
									},
								},
							},
							disclaimer = {
								order = 4, type = "description", name = "|cffff0000These are just examples, make sure you adjust them properly!|cffffffff",
							},
						},
					},
				},
			},
			tabSettings = {
				order = 2, type = "group", name = "Settings", args = {
					igRange = {
						order = 1, type = "group", inline = true, name = "Range check",
						args = {
							rangePerSkill = {
								type = "toggle", width = "full", name = "Range check for each skill instead of only melee range.",
								get = Get, set = Set,
							},
						},
					},
				},
			},
		},
	}
end
clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = LoadModule